import csv
from datetime import datetime
from datetime import timedelta
import numpy as np

fileName = "./star_trek.csv"

cin = []
cout = []
def computeDiffInMonth(date1, date2):
   yearDiff = date1.year - date2.year
   monthDiff = date1.month - date2.month
   return yearDiff*12 + monthDiff

with open(fileName, 'rb') as csvfile:
   spamreader = csv.reader(csvfile, delimiter=',')
   row1 = next(spamreader) # thrown away first row.
   for row in spamreader:
      cout.append(row[1])
      cin.append(row[2])

cinP = []
coutP = []

for i in xrange(0, len(cin)):
   cinP.append(datetime.strptime(cin[i], '%Y-%m-%d %H:%M:%S'))
   coutP.append(datetime.strptime(cout[i], '%Y-%m-%d %H:%M:%S'))
BuckStart = datetime.strptime("2012-01-01 12:00:00", '%Y-%m-%d %H:%M:%S')
BuckEnd = datetime.strptime("2018-01-01 12:00:00", '%Y-%m-%d %H:%M:%S')

#print (BuckStart)
FirstCout = min(coutP)
#print (FirstCout)

totalBucket = computeDiffInMonth(BuckEnd, BuckStart)
#print (totalBucket)

bucketList = []

averageBorrowInDays = np.zeros([totalBucket])

for i in xrange(0, totalBucket):
   TimeDiffList = []
   bucketList.append(TimeDiffList)

for i in xrange(0, len(coutP)):
   diffM = computeDiffInMonth(coutP[i], BuckStart)
   bucketList[diffM].append(cinP[i] - coutP[i])

totalRecord = np.zeros([totalBucket])

for i in xrange(0, totalBucket):
   numRecords = len(bucketList[i])
   totalRecord[i] = numRecords
   averageT = 0
   #if (numRecords != 0):
   #   averageT = min(bucketList[i]).days
   for Tdiff in bucketList[i]:
      averageT += Tdiff.days
   if (numRecords != 0):
      averageT /= numRecords
   #ri, averageT)
   averageBorrowInDays[i] = averageT

fout = open("./Star_trek_AveDays.txt", "w")
for i in xrange(0, totalBucket):
   fout.write("%d\n" % (int)(averageBorrowInDays[i]))
fout.close()